#ifndef __STDJIS_H
#define __STDJIS_H
//
//  (C) Copyright 1993-2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

#ifndef __STDISO_H
#error include 'stdISO.h' before including this file
#endif

#include "AdAChar.h"

class STDIMP_DLLSHARE AcmStandardJIS : public AcmStandard
{
public:
  ACRX_DECLARE_MEMBERS(AcmStandardJIS);

  AcmStandardJIS();
  virtual ~AcmStandardJIS();
  
  virtual LPCTSTR originalName() const;             

  virtual Adesk::Boolean acmInit();             

  virtual void getTextHeightList(AcGeDoubleArray& txtArr) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Adesk::Boolean setDimDefaults();

protected:
  virtual void initArrowServices();
  virtual Adesk::Boolean createDefaultStyle();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmStandardJIS);


class STDIMP_DLLSHARE AcmSurfTextStdJIS : public AcmSurfTextStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdJIS);

  AcmSurfTextStdJIS();
  virtual ~AcmSurfTextStdJIS();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual void initToEditOriginal();
  virtual void initToEdit();
  
  virtual Adesk::Boolean setFactoryDefaults();
  
  virtual Adesk::Boolean getLaySymbolList(AcmCObjArray<AcmCSymbolDesc>& list,
                                          const AcmCSurfText* pSubSym =NULL) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus setSuggested(AcmCSurfText* pData) const;

  virtual bool getSubEntsProd1(const AcmCSurfText* pSubSym,
                               AcmCAuxEntArray& subents,
                               AcDbExtents& fullExtent,
                               double txtHeight,
                               double& commonWidth,
                               AcGePoint3d& refPoint) const;
  virtual bool getSubEntsCutoff(const AcmCSurfText* pSubSym,
                                AcmCAuxEntArray& subents,
                                AcDbExtents& fullExtent,
                                double txtHeight,
                                double& commonWidth,
                                AcGePoint3d& refPoint) const;
  virtual bool getSubEntsOtherVal(const AcmCSurfText* pSubSym,
                                  AcmCAuxEntArray& subents,
                                  AcDbExtents& fullExtent,
                                  double txtHeight,
                                  double& commonWidth,
                                  AcGePoint3d& refPoint) const;

  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
  virtual void restoreAllSuggestedList();
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;

protected:
  virtual void getHeights(const AcmCSurfText* pSymb,
                          double& H1,
                          double& H2) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdJIS);

class STDIMP_DLLSHARE AcmSurfTextStdJIS2003 : public AcmSurfTextStdJIS
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdJIS2003);

  AcmSurfTextStdJIS2003();
  virtual ~AcmSurfTextStdJIS2003();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Adesk::Boolean getLaySymbolList(AcmCObjArray<AcmCSymbolDesc>& list,
                                          const AcmCSurfText* pSubSym =NULL) const;

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const ;
  virtual Acm::ErrorStatus setSuggested(AcmCSurfText* pData) const;
  virtual void restoreAllSuggestedList();
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;
  virtual void getDefaultLaySymbols(AcDbIntArray& symArray) const;

  virtual bool getSubEntsProd1(const AcmCSurfText* pSubSym,
                               AcmCAuxEntArray& subents,
                               AcDbExtents& fullExtent,
                               double txtHeight,
                               double& commonWidth,
                               AcGePoint3d& refPoint) const;

protected:
  virtual void getHeights(const AcmCSurfText* pSymb,
                          double& H1,
                          double& H2) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdJIS2003);


class STDIMP_DLLSHARE AcmFCFStdJIS : public AcmFCFStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmFCFStdJIS);

  AcmFCFStdJIS();
  virtual ~AcmFCFStdJIS();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Adesk::Boolean getArrowDesc(AcmCObjArray<AcmCArrowDesc>& list,Adesk::Boolean allSrv = Adesk::kTrue) const;

  virtual Adesk::Boolean getMat(AcmCObjArray<AcmCGDTSymbolDesc>& list) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCFCF* pData) const;
  virtual void getSubEntsAllAround(AcmCAuxEntArray& subents,
                                   const AcGeMatrix3d& mat) const;
  virtual Acm::ArrowType defaultSecondaryArrowType() const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmFCFStdJIS);

class STDIMP_DLLSHARE AcmFCFStdJIS98 : public AcmFCFStdJIS
{
public:
  ACRX_DECLARE_MEMBERS(AcmFCFStdJIS98);

  AcmFCFStdJIS98();
  virtual ~AcmFCFStdJIS98();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean getMat(AcmCObjArray<AcmCGDTSymbolDesc>& list) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmFCFStdJIS98);

class STDIMP_DLLSHARE AcmWeldingStdJIS : public AcmWeldingStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmWeldingStdJIS);

  AcmWeldingStdJIS();
  virtual ~AcmWeldingStdJIS();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Acm::ErrorStatus cInit();
  
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual void setDefaultSubSymbol(AcmCSubWelding* pData) const;

  virtual Adesk::Boolean   initPost(AcmCWeld* pWeld) const;
  virtual Acm::ErrorStatus getSuggestedFinished(CStringList& list);
  virtual Acm::ErrorStatus checkVisibility(AcmCSubWelding* pData) const;

  virtual Adesk::Boolean getWelds(const AcmCSubWelding *pSubWeld,
                                  Acm::WeldLocationFilter filter,
                                  AcmCObjArray<AcmCSymbolDesc>& list) const;

  virtual void getSubEnts(const AcmCSubWelding* pSubSym,
                          AcmCAuxEntArray& subents,
                          AcGePoint3d& ptRefEnd) const;
  
  virtual void setDefaultISOSettings();

protected:
  virtual Acm::ErrorStatus createDefaultLTypeIdentLine(const ACHAR* name);
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmWeldingStdJIS);


class STDIMP_DLLSHARE AcmDatumStdJIS : public AcmDatumStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmDatumStdJIS);

  AcmDatumStdJIS();
  virtual ~AcmDatumStdJIS();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean setFactoryDefaults();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmDatumStdJIS);


class STDIMP_DLLSHARE AcmIdStdJIS : public AcmIdStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmIdStdJIS);

  AcmIdStdJIS();
  virtual ~AcmIdStdJIS();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean getDatumArrowDesc(AcmCObjArray<AcmCArrowDesc>& list) const;
  virtual Acm::ArrowType defaultArrowType() const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmIdStdJIS);

class STDIMP_DLLSHARE AcmCPartListStdJIS : public AcmCPartListStd
{
public:
  AcmCPartListStdJIS(AcmBOMStd *std);
  virtual ~AcmCPartListStdJIS();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
};


class STDIMP_DLLSHARE AcmCBalloonStdJIS : public AcmCBalloonStd
{
public:
  AcmCBalloonStdJIS(AcmBOMStd *std);
  virtual ~AcmCBalloonStdJIS();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;

  virtual Acm::ErrorStatus cInit();
};

class STDIMP_DLLSHARE AcmBOMStdJIS : public AcmBOMStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmBOMStdJIS);

  AcmBOMStdJIS();
  virtual ~AcmBOMStdJIS();

  virtual Acm::ErrorStatus cInit();
  virtual Adesk::Boolean setFactoryDefaults();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmBOMStdJIS);

#endif // STDJIS
